#include <bits/stdc++.h>

using namespace std;

int N,Q;
vector<long long> d, p;
vector<long long> k;

long long odgovor(long long brojpitanja) {
    long long brojPlazme=0;
    long long i=1;
    long long dan=0;
    long long brojOdg=0;
    while (i<=brojpitanja) {
        if(d[dan]==i) {
           brojPlazme = brojPlazme + p[dan];
           dan++;
        }
        if(brojPlazme>0) {
            brojPlazme--;
            brojOdg++;
            i++;
        }
        else {
            i=d[dan];
        }
        if(i>d[N-1] && brojPlazme==0) {
            break;
        }
    }
    return brojOdg;
}

int main() {
    cin >> N >> Q;
    for(int i=0; i<N; i++) {
        long long tempd, tempp;
        cin >> tempd >> tempp;
        d.push_back(tempd);
        p.push_back(tempp);
    }
    for(int i=0; i<Q; i++) {
        long long tempk;
        cin >> tempk;
        k.push_back(tempk);
    }

    for(int i=0; i<Q; i++)
    cout << odgovor(k[i]) << endl;

    return 0;
}